                      { Apr 20, 1992 }
unit fun;
interface
uses NKK;

function F(x: numType; compos: integer): numType;
function DF(x: numType): numType;
procedure AllFix(FixMin,FixMax: numType);

const maxFun=14;
      maxComp=4;

var numDS: integer;  { 1 <= numDS <= maxFun }
    comp: integer;   { 1 <= comp <= maxComp }
    mu: numType;

const MaxNumFix=100;
var Fix, DFix: array[1..MaxNumFix] of numType;
const numFix: integer=0;

const {FixMin=-5.001;
      FixMax= 5.001;}
      FixNumStep=201;

const Fstr: array[1..maxFun] of string=
{1}     ('mu*x*(1-x)',
{2}      'sqr(x)+mu',
{3}      'mu*x',
{4}      'mu*(x^3-x)',
{5}      'mu*(x^3+x)',
{6}      'x^3-mu*x',
{7}      'mu*x;mu(1-x);1/2',
{8}      'mu*sin(x)',
{9}      'mu*{part.lin.}',
{10}     'mu*exp(x)',
{11}     'mu*x^2*(1-x)',
{12}     '4*x^3-mu*x',
{13}     'mu*x^3-4*x',
{14}     'mu*x*(2-3*x)');

implementation
{---------------------------------------------------------------------------}
function F(x: numType; compos: integer): numType;

procedure F1;
begin
   x:=mu*x*(1-x);
end;

procedure F2;
begin
   x:=sqr(x)+mu;
end;

procedure F3;
begin
   x:=mu*x;
end;

procedure F4;
begin
   x:=mu*(sqr(x)*x-x);
end;

procedure F5;
begin
   x:=mu*(sqr(x)*x+x);
end;

procedure F6;
begin
   x:=sqr(x)*x-mu*x;
end;

procedure F7;
begin
   if x<=0.5 then x:=mu*x else x:=mu*(1-x);
end;

procedure F8;
begin
   x:=mu*sin(x);
end;

procedure F9;
const xp: array[1..5] of integer=(1,2,3,4,5);
      yp: array[1..5] of integer=(3,5,4,2,1);
begin
   if x<xp[2] then
      x:=((yp[2]-yp[1])*x+(xp[2]*yp[1]-xp[1]*yp[2]))/(xp[2]-xp[1]) else
   if x<xp[3] then
      x:=((yp[3]-yp[2])*x+(xp[3]*yp[2]-xp[2]*yp[3]))/(xp[3]-xp[2]) else
   if x<xp[4] then
      x:=((yp[4]-yp[3])*x+(xp[4]*yp[3]-xp[3]*yp[4]))/(xp[4]-xp[3]) else
      x:=((yp[5]-yp[4])*x+(xp[5]*yp[4]-xp[4]*yp[5]))/(xp[5]-xp[4]);
   x:=mu*x;
end;

procedure F10;
begin
   x:=mu*exp(x);
end;

procedure F11;
begin
   x:=mu*sqr(x)*(1-x);
end;
procedure F12;
begin
   x:=4*sqr(x)*x-mu*x;
end;
procedure F13;
begin
   x:=mu*sqr(x)*x-3*x;
end;
procedure F14;
begin
   x:=mu*x*(2-3*x);
end;

var i: integer;
begin { F }
   for i:=1 to compos do
      case NumDS of
         1: F1;
         2: F2;
         3: F3;
         4: F4;
         5: F5;
         6: F6;
         7: F7;
         8: F8;
         9: F9;
        10: F10;
        11: F11;
        12: F12;
        13: F13;
        14: F14;
        else begin
                writeln('Discrete system ',NumDS,' not yet implemented');
                readln;
             end;
      end; { case }
   F:=x;
end; { F }
{---------------------------------------------------------------------------}
function DF(x: numType): numType;
var y: numType;

procedure F1;
begin
   y:=mu*(1-2*x);
end;

procedure F2;
begin
   y:=2*x;
end;

procedure F3;
begin
   y:=mu;
end;

procedure F4;
begin
   y:=mu*(3*sqr(x)-1);
end;

procedure F5;
begin
   y:=mu*(3*sqr(x)*x+1);
end;

procedure F6;
begin
   y:=3*sqr(x)*x-mu;
end;

procedure F7;
begin
   if x<=0.5 then y:=mu else y:=-mu;
end;

procedure F8;
begin
   y:=mu*cos(x);
end;

procedure F9;
const xp: array[1..5] of integer=(1,2,3,4,5);
      yp: array[1..5] of integer=(3,5,4,2,1);
begin
   if x<xp[2] then y:=yp[2]-yp[1] else
   if x<xp[3] then y:=yp[3]-yp[2] else
   if x<xp[4] then y:=yp[4]-yp[3] else y:=yp[5]-yp[4];
   y:=mu*y;
end;

procedure F10;
begin
   y:=mu*exp(x);
end;

procedure F11;
begin
   y:=mu*x*(2-3*x);
end;
procedure F12;
begin
   y:=12*sqr(x)-mu;
end;
procedure F13;
begin
   y:=3*mu*sqr(x)-3;
end;
procedure F14;
begin
   y:=2*mu*(1-3*x);
end;


var i: integer;
    r: numtype;
begin { DF }
   r:=1;
   for i:=1 to comp do
   begin
      case NumDS of
         1: F1;
         2: F2;
         3: F3;
         4: F4;
         5: F5;
         6: F6;
         7: F7;
         8: F8;
         9: F9;
        10: F10;
        11: F11;
        12: F12;
        13: F13;
        14: F14;
        else begin
                writeln('Discrete system ',NumDS,' not yet implemented');
                readln;
             end;
      end; { case }
      r:=r*y;
      x:=F(x,1);
   end;
   DF:=r;
end; { DF }
{---------------------------------------------------------------------------}
procedure AllFix;

function eq(x1,x2: numType; var x: numType): boolean;
var fx1, fx2, fx: numtype;
    i: integer;
const pre=1e-10;
      pre2=pre*pre;
begin
   eq:=true;
   fx1:=F(x1,comp)-x1; fx2:=F(x2,comp)-x2;
   if abs(fx1)<pre2 then
   begin
      x:=x1; exit;
   end else
   if abs(fx2)<pre2 then
   begin
      x:=x2; exit;
   end;

   i:=0;
   if fx1*fx2>0 then eq:=false else
   while (abs(x1-x2)>pre) and (fx1*fx2<0) and (i<1000) do
   begin
      i:=i+1;
      x:=(x1+x2)/2;
      fx:=F(x,comp)-x;
      if fx*fx1<0 then
      begin
         x2:=x; fx2:=fx;
      end else
      begin
         x1:=x; fx1:=fx;
      end;
   end;
   if i=1000 then eq:=false;
end; { eq }

var x1,x2, x, step: numType;

begin
   Step:=(FixMax-FixMin)/FixNumStep;
   x1:=FixMin;  x2:=x1+Step;
   numFix:=0;
   while x2<=FixMax do
   begin
      if eq(x1,x2, x) then
         if numFix<MaxNumFix then
      begin
         numFix:=numFix+1;
         Fix[numFix]:=x;
         DFix[numFix]:=DF(x);
      end;
      x1:=x2; x2:=x2+Step;
   end;
end;

end.